unit hiNumberToString;

interface

uses Kol,Share,Debug;

type
  THINumberToString = class(TDebug)
   private
   public
    _event_onResult:THI_Event;
    procedure _work_doNumToString(var _Data:TData; Index:word);
  end;

implementation



procedure THINumberToString._work_doNumToString;

{---------------      -------------}
function ConvertTriada(M: longint; fm: integer): string;
const
  From100to900: array[1..9] of string = ('', '', '', '', '', '', '', '', '');
  From10to90: array[1..9] of string = ('', '', '', '', '', '', '', '', '');
  From11to19: array[1..9] of string = ('', '', '', '', '', '', '', '', '');
  From1to9m: array[1..9] of string = ('', '', '', '', '', '', '', '', '');
  From1to9f: array[1..9] of string = ('', '', '', '', '', '', '', '', '');

var
   sTriada: string;
   i: integer;
 begin
   sTriada := '';
   i := M div 100;                                   //  
   if (i <> 0) then sTriada := From100to900[i] + ' ';
   M := M mod 100;                                   // 
   if (M  in[11..19])  then                          //  11  19 ?
     sTriada := sTriada +From11to19[M - 10] + ' '    // . 
   else                                              // 
     begin
       i := M div 10; 
       if i <> 0 then sTriada := sTriada + From10to90[i] + ' '; //  
       M := M mod 10;                                           // 
       if M <> 0 then
         if fm = 0 then
           sTriada := sTriada + From1to9f[M] + ' '
         else
           sTriada := sTriada + From1to9m[M] + ' '; 
     end;
   ConvertTriada := sTriada;
 end; 
{---------------      -------------}

var
i,j: longint;
r,S: real;
t: string;
begin
 S:=toReal(_Data);
    if S > 999999999999 then exit; 
 t := '';
 j := Trunc(S / 1000000000.0);
 r := j;
 r := S - r * 1000000000.0;
{********  **************}
 i := Trunc(r);
 if j <> 0 then
   begin
     t := t + ConvertTriada(j, 1) + '';
     if (j mod 100 in[11..19]) then
       t := t + ''
     else
       case j mod 10 of
         0,5..9: t := t + '';
         2..4: t := t + '';
       end;
       t:=t+' ';
   end;
{********  **************}   
j := i div 1000000;
if j <> 0 then
   begin
     t := t + ConvertTriada(j, 1) + '';
     if (j mod 100 in[11..19]) then
       t := t + ''
     else
       case j mod 10 of
         0,5..9: t := t + '';
         2..4: t := t + '';
       end;
       t:=t+' ';
   end;
{********  **************} 
i := i mod 1000000;
j := i div 1000;
if j <> 0 then
   begin
     t := t + ConvertTriada(j, 0) + '';
     if (j mod 100 in[11..19]) then
     else
       case j mod 10 of
         1: t := t + '';
         2..4: t := t + '';
       end;
      t := t + ' '
   end;
{********    **************}   
  j := i mod 1000;
  if j <> 0 then  t := t + ConvertTriada(j, 1);
  
  _hi_OnEvent(_event_onResult,t);
end;

end.
